'
'  Project: Zabbix Agent windows Installer
'  author: Michel.Manceron@suiviperf.com
'  name: Zabbix_agent.wxs
'  Object: custom action for wix installer script for zabbix agent on windows 32b and 64b

sub ChangeConfig 
  on error resume next
  dim ZABBIXSERVER,ZABBIXPORT,LISTENPORT,RCMD,InstallDir,Config,HOSTNAME
  InstallDir   = Session.Property("INSTALLDIR")
  ZABBIXSERVER = Session.Property("SERVER")
  ZABBIXPORT   = Session.Property("SPORT")  
  LISTENPORT   = Session.Property("LPORT")   
  RCMD         = Session.Property("RMTCMD")
  LOGFILE      = Session.Property("LOGFILE")                                                        
HOSTNAME     = Session.property("HOSTNAME")
  if HOSTNAME = "" then	
  	HOSTNAME     = session.Property("ComputerName")
  end if 	
  if LOGFILE = "" then LOGFILE=InstallDir & "Zabbix_agentd.log"       
  ' 
  Loginfo ("Reading file "& InstallDir & "zabbix_agentd.conf")
  Config =  ReadAllText (InstallDir & "zabbix_agentd.conf")
  If err.number <> 0 Then
      Loginfo ("Reading file "& InstallDir & "zabbix_agentd.conf Error(" & err.number & ") "& Err.Description)
      exit sub
  end if 
  Config =  Replace (Config,"{SERVER}",ZABBIXSERVER)
  Config =  Replace (Config,"{SPORT}",ZABBIXPORT)
  Config =  Replace (Config,"{LPORT}",LISTENPORT)
  Config =  Replace (Config,"{HOSTNAME}",HOSTNAME)
  Config =  Replace (Config,"{RMTCMD}",RCMD)
  Config =  Replace (Config,"{LogFile}",LOGFILE)
  Loginfo ("Writing file "& InstallDir & "zabbix_agentd.conf")
  WriteAllText InstallDir & "zabbix_agentd.conf",Config
  If err.number <> 0 Then
      Loginfo ("Writing file "& InstallDir & "zabbix_agentd.conf Error(" & err.number & ") "& Err.Description)
      exit sub
  end if 
    Loginfo ("Configuration file is finished.")
end sub

Function ReadAllText(path)
   Dim fso, stream
   
   Set fso=CreateObject("Scripting.FileSystemObject")
   
   Set stream=fso.OpenTextFile(CStr(path))
   ReadAllText=stream.ReadAll()
   stream.Close
   
   Set stream=Nothing
   Set fso=Nothing
End Function

Sub WriteAllText(path, contents)
   Dim fso, stream
   
   Set fso=CreateObject("Scripting.FileSystemObject")
   Set stream=fso.CreateTextFile(CStr(path))
   stream.Write CStr(contents)
   stream.Close
   
   Set stream=Nothing
   Set fso=Nothing
End Sub 

Function LogInfo(msg) Dim rec
     Set rec = Session.Installer.CreateRecord(1)
     rec.StringData(0) = msg
     LogInfo = Session.Message(&H04000000, rec)
End Function
sub sleeping
	n= dateadd("s",10,now)
	do while  0 < DateDiff ( "s",  now , n)
	loop
end sub 
